package kr.co.iya.base.aspect;

import java.util.Locale;

import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.annotation.Around;
import org.aspectj.lang.annotation.Aspect;
import org.springframework.stereotype.Component;

import kr.co.iya.base.context.PageContext;
import kr.co.iya.base.support.AbstractMeta;

@Aspect
@Component
public class KafkaListenerAspect extends AbstractMeta {

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	@Around(value="@annotation(org.springframework.kafka.annotation.KafkaListener)")
	public Object around(ProceedingJoinPoint joinPoint) throws Throwable {

		MetaUtil.getThreadLocalMap().put("locale",Locale.KOREAN);
		MetaUtil.getThreadLocalMap().put("pageContext",new PageContext());
		
		try {
			return joinPoint.proceed();			
		}catch(Exception e) {		
			throw e;
		}finally {		
			MetaUtil.getThreadLocalMap().remove("locale");		
			MetaUtil.getThreadLocalMap().remove("pageContext");
		}
	}
	
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
}