package kr.co.iya.base.config;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.autoconfigure.condition.ConditionalOnExpression;
import org.springframework.boot.autoconfigure.condition.ConditionalOnWebApplication;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import io.swagger.v3.oas.models.OpenAPI;
import io.swagger.v3.oas.models.info.Info;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Configuration
@ConditionalOnExpression("T(kr.co.iya.base.SwaggerConfig).isEnabled()")
@ConditionalOnWebApplication
public class SwaggerConfig {

	@Value("${spring.profiles.active:local}")
	private String springProfilesActive;
	
	@Value("${project.name:project.name}")
    private String name;

    @Value("${project.description:project.description}")
    private String description;

    @Value("${project.version:project.version}")
    private String version;

    @Bean
    OpenAPI openAPI() {

    	Info info = new Info();
    	info.setTitle(this.name+"-"+this.springProfilesActive);
    	info.setDescription(this.description);
    	info.version(this.version);
    	
    	log.debug("swaager service name : {} ",this.name+"-"+this.springProfilesActive);
      	
    	OpenAPI openApi = new OpenAPI();
        openApi.setInfo(info);
    	
    	return openApi;
    }

}
