package kr.co.iya.base.context;

import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

@Component
@ConfigurationProperties(prefix="project")
public class ProjectContext {

	  private String groupId;
	  private String artifact;
	  private String version;
	  private String name;
	  private String description;
	  
	  private Meta meta;
	  private Build build;
	  
	  public String getGroupId() {return groupId;}
	  public void setGroupId(String groupId) {this.groupId = groupId;}
	  
	  public String getArtifact() {return artifact;}
	  public void setArtifact(String artifact) {this.artifact = artifact;}
	  
	  public String getVersion() {return version;}
	  public void setVersion(String version) {this.version = version;}
	  
	  public String getName() {return name;}
	  public void setName(String name) {this.name = name;}
	  
	  public String getDescription() {return description;}
	  public void setDescription(String description) {this.description = description;}

	  public Meta getMeta() {return meta;}
	  public void setMeta(Meta meta) {this.meta = meta;}
	  
	  public Build getBuild() {return build;}
	  public void setBuild(Build build) {this.build = build;}
	  
	  public static class Meta{
		  private String group;
		  private String service;
		  private String jobId;
		  
		  public String getGroup() {return group;}
		  public void setGroup(String group) {this.group = group;}
		  public String getService() {return service;}
		  public void setService(String service) {this.service = service;}
		  public String getJobId() {return jobId;}
		  public void setJobId(String jobId) {this.jobId = jobId;}
		  
	  }
	  
	  public static class Build{
		  private String finalName;
		  private String revision;
		  private String branch;
		  private String timestamp;
		  
		  public String getFinalName() {return finalName;}
		  public void setFinalName(String finalName) {this.finalName = finalName;}
		  public String getRevision() {return revision;}
		  public void setRevision(String revision) {this.revision = revision;}
		  public String getBranch() {return branch;}
		  public void setBranch(String branch) {this.branch = branch;}
		  public String getTimestamp() {return timestamp;}
		  public void setTimestamp(String timestamp) {this.timestamp = timestamp;}
	  }
}

