package kr.co.iya.base.exception;

import org.springframework.http.HttpStatus;

import kr.co.iya.base.advice.ExceptionAdvice.ExceptionMessageLambda;

public class SystemException extends RuntimeException{

	private static final long serialVersionUID = 1L;
	
	private final String message;

	private final HttpStatus httpStatus;

	public String getMessage() {
		return message;
	}

	public HttpStatus getHttpStatus() {
		return httpStatus;
	}

	public SystemException(ExceptionMessageLambda messageLambda) {
		this(messageLambda.getMessage());
	}
	
	public SystemException(String message) {
		this(message,HttpStatus.INTERNAL_SERVER_ERROR);
	}

	public SystemException(ExceptionMessageLambda messageLambda, HttpStatus httpStatus) {
		this(messageLambda.getMessage(),httpStatus);
	}
	
	public SystemException(String message, HttpStatus httpStatus) {
		super(message);
		this.message = message;
		this.httpStatus = httpStatus;
	}

}