package kr.co.iya.base.support;

import org.springframework.http.HttpHeaders;

import kr.co.iya.base.context.MaskContext;
import kr.co.iya.base.context.PageContext;
import kr.co.iya.base.support.aid.ContextAid;
import kr.co.iya.base.support.util.Base64UtilPack.Base64Util;
import kr.co.iya.base.support.util.BashProcessUtilPack.BashProcessUtil;
import kr.co.iya.base.support.util.CompressUtilPack.CompressUtil;
import kr.co.iya.base.support.util.CryptoUtilPack.CryptoUtil;
import kr.co.iya.base.support.util.FileUtilPack.FileUtil;
import kr.co.iya.base.support.util.JsonUtilPack.JsonUtil;
import kr.co.iya.base.support.util.LobConverterUtilPack.LobConverterUtil;
import kr.co.iya.base.support.util.LocaleUtilPack.LocaleUtil;
import kr.co.iya.base.support.util.MaskUtilPack.MaskUtil;
import kr.co.iya.base.support.util.MessageUtilPack.MessageUtil;
import kr.co.iya.base.support.util.ObjectMapperUtilPack.ObjectMapperUtil;
import kr.co.iya.base.support.util.PropertiesUtilPack.PropertiesUtil;
import kr.co.iya.base.support.util.RestTemplateUtilPack.RestTemplateUtil;
import kr.co.iya.base.support.util.SftpUtilPack.SftpUtil;
import kr.co.iya.base.support.util.SystemUtilPack.SystemUtil;
import kr.co.iya.base.support.util.ThreadUtilPack.ThreadUtil;
import kr.co.iya.base.support.util.TimeUtilPack.TimeUtil;
import kr.co.iya.base.support.util.TransactionUtilPack.TransactionUtil;

public abstract class AbstractMetaBatch extends AbstractMeta {

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	public static final PageContext getPageContext() {return ContextAid.getPageContext();}
    public static final PageContext getPageContext(int totalCount) {return ContextAid.getPageContext(totalCount);}
    public static final PageContext getPageContext(HttpHeaders header) {return ContextAid.getPageContext(header);}
    public static final MaskContext getMaskContext() {return ContextAid.getMaskContext();}
    
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	public static final Base64Util getBase64Util() {return MetaUtil.getBase64Util();}
	public static final BashProcessUtil getBashProcessUtil() {return MetaUtil.getBashProcessUtil();}	
	public static final CompressUtil getCompressUtil() {return MetaUtil.getCompressUtil();} 
	public static final CryptoUtil getCryptoUtil() {return MetaUtil.getCryptoUtil();} 
	public static final FileUtil getFileUtil() { return MetaUtil.getFileUtil();} 

	public static final JsonUtil getJsonUtil() {return MetaUtil.getJsonUtil();}
	public static final LobConverterUtil getLobConvertUtil() {return MetaUtil.getLobConvertUtil();}
	public static final LocaleUtil getLocaleUtil() {return MetaUtil.getLocaleUtil();} 
	public static final MaskUtil getMaskUtil() {return MetaUtil.getMaskUtil();} 	
	public static final MessageUtil getMessageUtil() {return MetaUtil.getMessageUtil();} 
	public static final ObjectMapperUtil getObjectMapperUtil() {return MetaUtil.getObjectMapperUtil();}
	public static final PropertiesUtil getPropertiesUtil() {return MetaUtil.getPropertiesUtil();}
	public static final RestTemplateUtil getRestTemplateUtil() {return MetaUtil.getRestTemplateUtil();} 	

	public static final SftpUtil getSftpUtil() {return MetaUtil.getSftpUtil();}
	public static final SystemUtil getSystemUtil() {return MetaUtil.getSystemUtil();}
	public static final ThreadUtil getThreadUtil() {return MetaUtil.getThreadUtil();}
	public static final TimeUtil getTimeUtil() {return MetaUtil.getTimeUtil();} 
    public static final TransactionUtil getTransactionUtil() {return MetaUtil.getTransactionUtil();}	
    
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}